#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_cJIK24x24x24NN0x0x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=24, NB=24, KB=24, 
 * lda=0, ldb=0, ldc=0, mu=4, nu=1, ku=24, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const float *stM = A + 48;
   const float *stN = B + (((ldb) << 5)+((ldb) << 4));
   const float *pfA = A + lda*M;
   const int incAk = (((lda) << 1));
   const int incAm = 8 - (((lda) << 5)+((lda) << 4)), incAn = -48;
   #define incBk 48
   const int incBm = -48, incBn = (((ldb) << 1));
   #define incAk0 incAk
   const int incBk0 = ((incBk) / 24);
   #define incCm 8
   const int incCn = (((ldc) << 1)) - 48;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0, m1, m2, m3, m4, m5, m6, m7;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[2];
         rC1_0 *= rA0;
         rC2_0 = pC0[4];
         rC2_0 *= rA0;
         rC3_0 = pC0[6];
         rC3_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[2];
         m0 = rA0 * rB0;
         rA2 = pA0[4];
         rA3 = pA0[6];
         m1 = rA1 * rB0;
         m2 = rA2 * rB0;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[2];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         m4 = rA0 * rB0;
         m5 = rA1 * rB0;
         m6 = rA2 * rB0;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[4];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];

/*
 *       Completely unrolled K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[6];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[8];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[10];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[12];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[14];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[16];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[18];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[20];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[22];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[24];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[26];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[28];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[30];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[32];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[34];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[36];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[38];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[40];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[42];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[44];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC1_0 += m1;
         m1 = rA1 * rB0;
         rC2_0 += m2;
         m2 = rA2 * rB0;
         rC3_0 += m3;
         m3 = rA3 * rB0;
         pA0 += incAk;
         rA0 = *pA0;
         rB0 = pB0[46];
         rA1 = pA0[2];
         rA2 = pA0[4];
         rA3 = pA0[6];
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m4;
         m4 = rA0 * rB0;
         rC1_0 += m5;
         m5 = rA1 * rB0;
         rC2_0 += m6;
         m6 = rA2 * rB0;
         rC3_0 += m7;
         m7 = rA3 * rB0;
         pA0 += incAk;
         rC0_0 += m0;
         rC1_0 += m1;
         rC2_0 += m2;
         rC3_0 += m3;
         rC0_0 += m4;
         rC1_0 += m5;
         rC2_0 += m6;
         rC3_0 += m7;
         pB0 += incBk;
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
