#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK6x36x36TN6x1x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=6, NB=36, KB=36, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (((lda) << 3)+((lda) << 2));
   const double *stN = B + (((ldb) << 6)+((ldb) << 3));
   const double *pfA = A + M;
   #define incAk 2
   const int incAm = ((((((lda) << 2)+((lda) << 1)) - 36) << 1)), incAn = -(((lda) << 3)+((lda) << 2));
   #define incBk 2
   const int incBm = -72, incBn = (((ldb) << 1));
   #define incCm 12
   const int incCn = (((ldc) << 1)) - 12;
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1)), *pA4=pA3+(((lda) << 1)), *pA5=pA4+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      pfA += lda;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      ATL_pfl1W(pC0);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rC0_0 = rA0 * rB0;
      rA1 = *pA1;
      rC1_0 = rA1 * rB0;
      rA2 = *pA2;
      rC2_0 = rA2 * rB0;
      rA3 = *pA3;
      rC3_0 = rA3 * rB0;
      rA4 = *pA4;
      rC4_0 = rA4 * rB0;
      rA5 = *pA5;
      rC5_0 = rA5 * rB0;
      pA0 += incAk;
      pA1 += incAk;
      pA2 += incAk;
      pA3 += incAk;
      pA4 += incAk;
      pA5 += incAk;
      pB0 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=0; k < 35; k++) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA1 = *pA1;
         rC1_0 += rA1 * rB0;
         rA2 = *pA2;
         rC2_0 += rA2 * rB0;
         rA3 = *pA3;
         rC3_0 += rA3 * rB0;
         rA4 = *pA4;
         rC4_0 += rA4 * rB0;
         rA5 = *pA5;
         rC5_0 += rA5 * rB0;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0[4] = rC2_0;
      pC0[6] = rC3_0;
      pC0[8] = rC4_0;
      pC0[10] = rC5_0;
      pC0 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pA2 += incAm;
      pA3 += incAm;
      pA4 += incAm;
      pA5 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK36x36x36TN0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=36, NB=36, KB=36, 
 * lda=0, ldb=0, ldc=0, mu=10, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (60*(lda));
   const double *stN = B + (((ldb) << 6)+((ldb) << 3));
   const double *pfA = A + M;
   #define incAk 2
   const int incAm = ((((((lda) << 3)+((lda) << 1)) - 36) << 1)), incAn = -(60*(lda));
   #define incBk 2
   const int incBm = -72, incBn = (((ldb) << 1));
   #define incCm 20
   const int incCn = (((ldc) << 1)) - 60;
   double *pC0=C;
   const double *pA0=A, *pA1=pA0+(((lda) << 1)), *pA2=pA1+(((lda) << 1)), *pA3=pA2+(((lda) << 1)), *pA4=pA3+(((lda) << 1)), *pA5=pA4+(((lda) << 1)), *pA6=pA5+(((lda) << 1)), *pA7=pA6+(((lda) << 1)), *pA8=pA7+(((lda) << 1)), *pA9=pA8+(((lda) << 1));
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         ATL_pfl1W(pC0);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 = rA0 * rB0;
         rA1 = *pA1;
         rC1_0 = rA1 * rB0;
         rA2 = *pA2;
         rC2_0 = rA2 * rB0;
         rA3 = *pA3;
         rC3_0 = rA3 * rB0;
         rA4 = *pA4;
         rC4_0 = rA4 * rB0;
         rA5 = *pA5;
         rC5_0 = rA5 * rB0;
         rA6 = *pA6;
         rC6_0 = rA6 * rB0;
         rA7 = *pA7;
         rC7_0 = rA7 * rB0;
         rA8 = *pA8;
         rC8_0 = rA8 * rB0;
         rA9 = *pA9;
         rC9_0 = rA9 * rB0;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
         pA6 += incAk;
         pA7 += incAk;
         pA8 += incAk;
         pA9 += incAk;
         pB0 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=0; k < 35; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA1 = *pA1;
            rC1_0 += rA1 * rB0;
            rA2 = *pA2;
            rC2_0 += rA2 * rB0;
            rA3 = *pA3;
            rC3_0 += rA3 * rB0;
            rA4 = *pA4;
            rC4_0 += rA4 * rB0;
            rA5 = *pA5;
            rC5_0 += rA5 * rB0;
            rA6 = *pA6;
            rC6_0 += rA6 * rB0;
            rA7 = *pA7;
            rC7_0 += rA7 * rB0;
            rA8 = *pA8;
            rC8_0 += rA8 * rB0;
            rA9 = *pA9;
            rC9_0 += rA9 * rB0;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pA4 += incAk;
            pA5 += incAk;
            pA6 += incAk;
            pA7 += incAk;
            pA8 += incAk;
            pA9 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0[12] = rC6_0;
         pC0[14] = rC7_0;
         pC0[16] = rC8_0;
         pC0[18] = rC9_0;
         pC0 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pA5 += incAm;
         pA6 += incAm;
         pA7 += incAm;
         pA8 += incAm;
         pA9 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pA6 += incAn;
      pA7 += incAn;
      pA8 += incAn;
      pA9 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_zJIK6x36x36TN6x1x1_a1_b0(6, 36, 36, alpha, ca + (60*(lda)), lda, cb, ldb, beta, cc + 60, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
