#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_zJIK4x0x54TN4x1x6_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=4, NB=0, KB=54, 
 * lda=54, ldb=54, ldc=0, mu=4, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const double *stM = A + 216;
   const double *stN = B + (54*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(4*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 162, incAn = -216;
   #define incBk 6
   const int incBm = -54, incBn = 54;
   #define incCm 8
   const int incCn = (((ldc) << 1)) - 8;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA);
      pfA += incPFA;
      rC0_0 = *pC0;
      rC1_0 = pC0[2];
      rC2_0 = pC0[4];
      rC3_0 = pC0[6];
      for (k=0; k < 9; k++) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rC0_0 += rA0 * rB0;
         rA1 = pA0[54];
         rA2 = pA0[108];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[162];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[55];
         rA2 = pA0[109];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[163];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[2];
         rB0 = pB0[2];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[56];
         rA2 = pA0[110];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[164];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[3];
         rB0 = pB0[3];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[57];
         rA2 = pA0[111];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[165];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[4];
         rB0 = pB0[4];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[58];
         rA2 = pA0[112];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[166];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rA0 = pA0[5];
         rB0 = pB0[5];
         rC0_0 += rA0 * rB0;
         rA1 = pA0[59];
         rA2 = pA0[113];
         rC1_0 += rA1 * rB0;
         rA3 = pA0[167];
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      }
      *pC0 = rC0_0;
      pC0[2] = rC1_0;
      pC0[4] = rC2_0;
      pC0[6] = rC3_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_zJIK54x0x54TN54x54x0_a1_b1
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=54, NB=0, KB=54, 
 * lda=54, ldb=54, ldc=0, mu=10, nu=1, ku=6, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + 2700;
   const double *stN = B + (54*(Nb));
   const double *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*10*1)/(54*N*sizeof(double));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 6
   const int incAm = 486, incAn = -2700;
   #define incBk 6
   const int incBm = -54, incBn = 54;
   #define incCm 20
   const int incCn = (((ldc) << 1)) - 100;
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7, rA8, rA9;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC8_0, rC9_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rC0_0 = *pC0;
         rC1_0 = pC0[2];
         rC2_0 = pC0[4];
         rC3_0 = pC0[6];
         rC4_0 = pC0[8];
         rC5_0 = pC0[10];
         rC6_0 = pC0[12];
         rC7_0 = pC0[14];
         rC8_0 = pC0[16];
         rC9_0 = pC0[18];
         for (k=0; k < 9; k++) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            rA1 = pA0[54];
            rA2 = pA0[108];
            rC1_0 += rA1 * rB0;
            rA3 = pA0[162];
            rA4 = pA0[216];
            rC2_0 += rA2 * rB0;
            rA5 = pA0[270];
            rA6 = pA0[324];
            rC3_0 += rA3 * rB0;
            rA7 = pA0[378];
            rA8 = pA0[432];
            rC4_0 += rA4 * rB0;
            rA9 = pA0[486];
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[55];
            rA2 = pA0[109];
            rC1_0 += rA1 * rB0;
            rA3 = pA0[163];
            rA4 = pA0[217];
            rC2_0 += rA2 * rB0;
            rA5 = pA0[271];
            rA6 = pA0[325];
            rC3_0 += rA3 * rB0;
            rA7 = pA0[379];
            rA8 = pA0[433];
            rC4_0 += rA4 * rB0;
            rA9 = pA0[487];
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rA0 = pA0[2];
            rB0 = pB0[2];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[56];
            rA2 = pA0[110];
            rC1_0 += rA1 * rB0;
            rA3 = pA0[164];
            rA4 = pA0[218];
            rC2_0 += rA2 * rB0;
            rA5 = pA0[272];
            rA6 = pA0[326];
            rC3_0 += rA3 * rB0;
            rA7 = pA0[380];
            rA8 = pA0[434];
            rC4_0 += rA4 * rB0;
            rA9 = pA0[488];
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rA0 = pA0[3];
            rB0 = pB0[3];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[57];
            rA2 = pA0[111];
            rC1_0 += rA1 * rB0;
            rA3 = pA0[165];
            rA4 = pA0[219];
            rC2_0 += rA2 * rB0;
            rA5 = pA0[273];
            rA6 = pA0[327];
            rC3_0 += rA3 * rB0;
            rA7 = pA0[381];
            rA8 = pA0[435];
            rC4_0 += rA4 * rB0;
            rA9 = pA0[489];
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rA0 = pA0[4];
            rB0 = pB0[4];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[58];
            rA2 = pA0[112];
            rC1_0 += rA1 * rB0;
            rA3 = pA0[166];
            rA4 = pA0[220];
            rC2_0 += rA2 * rB0;
            rA5 = pA0[274];
            rA6 = pA0[328];
            rC3_0 += rA3 * rB0;
            rA7 = pA0[382];
            rA8 = pA0[436];
            rC4_0 += rA4 * rB0;
            rA9 = pA0[490];
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            rA0 = pA0[5];
            rB0 = pB0[5];
            rC0_0 += rA0 * rB0;
            rA1 = pA0[59];
            rA2 = pA0[113];
            rC1_0 += rA1 * rB0;
            rA3 = pA0[167];
            rA4 = pA0[221];
            rC2_0 += rA2 * rB0;
            rA5 = pA0[275];
            rA6 = pA0[329];
            rC3_0 += rA3 * rB0;
            rA7 = pA0[383];
            rA8 = pA0[437];
            rC4_0 += rA4 * rB0;
            rA9 = pA0[491];
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC7_0 += rA7 * rB0;
            rC8_0 += rA8 * rB0;
            rC9_0 += rA9 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         *pC0 = rC0_0;
         pC0[2] = rC1_0;
         pC0[4] = rC2_0;
         pC0[6] = rC3_0;
         pC0[8] = rC4_0;
         pC0[10] = rC5_0;
         pC0[12] = rC6_0;
         pC0[14] = rC7_0;
         pC0[16] = rC8_0;
         pC0[18] = rC9_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_zJIK4x0x54TN4x1x6_a1_b1(4, N, 54, alpha, ca + 2700, lda, cb, ldb, beta, cc + 100, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifdef ATL_UCLEANN
#define ATL_zpNBmm_b1 ATL_zgpNBmm_b1
#endif

void ATL_zJIK54x0x54TN54x54x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK54x0x54TN54x54x0_a1_bX(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);
void ATL_zJIK54x0x54TN54x54x0_a1_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc);

void ATL_zpNBmm_b1(const int M, const int N, const int K, const double alpha, const double *A, const int lda, const double *B, const int ldb, const double beta, double *C, const int ldc)
{
   ATL_zJIK54x0x54TN54x54x0_a1_bX(M, N, K, alpha, A, lda, B, ldb, -beta, C, ldc);
   ATL_zJIK54x0x54TN54x54x0_a1_bX(M, N, K, alpha, A, lda, B+N*ldb, ldb, beta, C+1, ldc);
   ATL_zJIK54x0x54TN54x54x0_a1_bX(M, N, K, alpha, A+M*lda, lda, B+N*ldb, ldb, -1.0, C, ldc);
   ATL_zJIK54x0x54TN54x54x0_a1_b1(M, N, K, alpha, A+M*lda, lda, B, ldb, 1.0, C+1, ldc);
}
